//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "hyiedefs"
#pragma link "hyieutils"
#pragma link "ieopensavedlg"
#pragma link "iesettings"
#pragma link "ievect"
#pragma link "ieview"
#pragma link "iexBitmaps"
#pragma link "imageenview"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
dll_instance =  LoadLibrary(L"Orsa.dll");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
// dll call
executeEntry("ORSA_Clean");
if (dll_instance)
   FreeLibrary(dll_instance);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
PaintSource->Blank();
PaintTarget->Blank();
prevSigma = trackSigma->Position;
// dll call
executeEntry("ORSA_Init");
//
SiftParams.InitSigma	 = trackSigma->Position / 10.0;
SiftParams.DoubleImSize = 0;
DataOrsa.rgb[0] = 0xff;
DataOrsa.rgb[1] = 0xff;
DataOrsa.rgb[2] = 0xff;
trackSigmaChange(this);
trackMatchChange(this);
trackPrecissionChange(this);
PageControl1->ActivePageIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnLoadSourceClick(TObject *Sender)
{
if (openDialog->Execute())
   {
   PaintSource->RemoveAllObjects();
   PaintSource->IO->LoadFromFile(openDialog->FileName);
   getScline(DataOrsa.Source.Image, PaintSource->IEBitmap);
   PageControl1->ActivePageIndex = 0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnLoadTargetClick(TObject *Sender)
{
if (openDialog->Execute())
   {
   PaintTarget->RemoveAllObjects();
   PaintTarget->IO->LoadFromFile(openDialog->FileName);
   getScline(DataOrsa.Target.Image, PaintTarget->IEBitmap);
   PageControl1->ActivePageIndex = 1;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSiftSourceClick(TObject *Sender)
{
processSift(PaintSource);
PageControl1->ActivePageIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSiftTargetClick(TObject *Sender)
{
processSift(PaintTarget);
PageControl1->ActivePageIndex = 1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnMatchClick(TObject *Sender)
{
if (PaintSource->IEBitmap->Width < 10)
   return;
if (PaintTarget->IEBitmap->Width < 10)
   return;
if (DataOrsa.Source.KeyPoints.Count == 0  || prevSigma != trackSigma->Position)
   btnSiftSourceClick(this);
if (DataOrsa.Target.KeyPoints.Count == 0 || prevSigma != trackSigma->Position)
   btnSiftTargetClick(this);
processMatches();
PageControl1->ActivePageIndex = 2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::processSift(TImageEnVect *paint)
{
if (!dll_instance)
   return;
if (paint->IEBitmap->Width < 10)
	return;
TStatusBar *bar;
String entry_name;
keypointsData *keyPoints;
if (paint == PaintSource)
   {
   bar = StatusBarSource;
   entry_name = "ORSA_SIFT_Descriptor_Source";
   DataOrsa.Source.KeyPoints;
   keyPoints = &DataOrsa.Source.KeyPoints;
   }
else
   {
   bar = StatusBarTarget;
   entry_name = "ORSA_SIFT_Descriptor_Target";
   keyPoints = &DataOrsa.Target.KeyPoints;
   }
bar->Panels->Items[0]->Text = "Processing...";
bar->Panels->Items[1]->Text = "";
bar->Panels->Items[2]->Text = "";
bar->Refresh();
TTime stime = Time(), etime, duration;
// remove all objects
paint->RemoveAllObjects();
// dll call
executeEntry(entry_name);
// show keypoints
int hobj, radius;
keypoint key;
for (int i = 0; i < keyPoints->Count; i++)
   {
   key = keyPoints->Data[i];
   hobj = paint->AddNewObject();
   radius = ceil(key.scale * SiftParams.InitSigma);  // initial sigma
   paint->ObjPenColor[hobj] = clAqua;
   paint->ObjKind[hobj] = iekELLIPSE;
   //paint->ObjTop[hobj] =  PaintView->IEBitmap->Height - 1 - (int)kfDesc[i].x - radius;
   paint->ObjTop[hobj]  =  key.y - radius;
   paint->ObjLeft[hobj] =  key.x - radius;
   paint->ObjWidth[hobj] =  radius*2;
   paint->ObjHeight[hobj] = radius*2;
   }
paint->Update();
etime = Time();
duration = etime - stime;
bar->Panels->Items[0]->Text = "Done!";
bar->Panels->Items[1]->Text = "Time elapsed: " + duration.FormatString("hh:nn:ss.zzzz");
bar->Panels->Items[2]->Text = "Key points: " + IntToStr(keyPoints->Count);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::processMatches(void)
{
if (!dll_instance)
   return;
StatusBarMatch->Panels->Items[0]->Text = "";
StatusBarMatch->Panels->Items[1]->Text = "";
StatusBarMatch->Panels->Items[2]->Text = "";
StatusBarMatch->Panels->Items[3]->Text = "";
StatusBarMatch->Panels->Items[4]->Text = "";
TTime stime = Time(), etime, duration;
SiftParams.MatchRatio   = trackMatch->Position / 10.0f;
int height = Max(PaintSource->IEBitmap->Height, PaintTarget->IEBitmap->Height);
TIEBitmap *bmp = new TIEBitmap(PaintSource->IEBitmap->Width + PaintTarget->IEBitmap->Width, height, ie24RGB);
bmp->Fill(0);
PaintSource->IEBitmap->DrawToTIEBitmap(bmp, 0, 0);
PaintTarget->IEBitmap->DrawToTIEBitmap(bmp, PaintSource->IEBitmap->Width, 0);
PaintMatch->IEBitmap->AssignImage(bmp);
delete bmp;
StatusBarMatch->Panels->Items[0]->Text = "Processing...";
// dll call
executeEntry("ORSA_SIFT_Matches");
// show matches
rgpMatches->ItemIndex = 0;
showMatches(0);
prevSigma = trackSigma->Position;
PaintMatch->Update();
etime = Time();
duration = etime - stime;
StatusBarMatch->Panels->Items[0]->Text = "Done!";
StatusBarMatch->Panels->Items[1]->Text = "Time elapsed: " + duration.FormatString("hh:nn:ss.zzzz");
StatusBarMatch->Panels->Items[2]->Text = "Valid matches: " + IntToStr(DataOrsa.SiftMatch.Count);
StatusBarMatch->Panels->Items[3]->Text = "Discarded: "+ IntToStr(DataOrsa.Source.KeyPoints.Count - DataOrsa.SiftMatch.Count);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::showMatches(int index)
{
PaintMatch->RemoveAllObjects();
TColor lineColor;
int hobj;
matchings match;
matchData *matchList;
switch (index)
   {
   case 1:
		matchList = &DataOrsa.InLiers;
		lineColor = clLime;
		break;
   case 2:
		matchList = &DataOrsa.OutLiers;
		lineColor = clRed;
		break;
   default:
		matchList = &DataOrsa.SiftMatch;
		lineColor = clAqua;
		break;
   }
for (int i = 0; i < matchList->Count; i++)
	{
	match = matchList->Data[i];
	hobj = PaintMatch->AddNewObject();
	PaintMatch->ObjPenColor[hobj] = lineColor;
	PaintMatch->ObjKind[hobj] = iekLINE;
	PaintMatch->ObjPenWidth[hobj] = 1;
	PaintMatch->ObjTop[hobj]    =  match.y1;
	PaintMatch->ObjLeft[hobj]   =  match.x1;
	PaintMatch->ObjHeight[hobj] =  match.y2 - PaintMatch->ObjTop[hobj];
	PaintMatch->ObjWidth[hobj]  =  match.x2 - PaintMatch->ObjLeft[hobj] + PaintSource->IEBitmap->Width;
	PaintMatch->ObjID[hobj] = i;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnOrsaClick(TObject *Sender)
{
if (!dll_instance)
   return;
TTime stime = Time(), etime, duration;
StatusBarMatch->Panels->Items[4]->Text = "ORSA running...";
StatusBarMatch->Refresh();
DataOrsa.Precission = trackPrecission->Position/10.0;
int ExecutionStatus;
// dll call
executeEntry("ORSA_Homography");
//
rgpMatches->ItemIndex = 1;
showMatches(1);
int w, h;
if (DataOrsa.OutputPanorama)
   {
   TIEBitmap *panorama = BitmapFromScline(DataOrsa.Panorama);
   PaintPanorama->IEBitmap->AssignImage(panorama);
   delete panorama;
   chkIntersectionClick(this);
   }
// reg 1
if (DataOrsa.OutputReg1)
   {
   TIEBitmap *reg1 = BitmapFromScline(DataOrsa.Reg1);
   PaintReg1->IEBitmap->AssignImage(reg1);
   delete reg1;
   }
// reg 2
if (DataOrsa.OutputReg2)
   {
   TIEBitmap *reg2 = BitmapFromScline(DataOrsa.Reg2);
   PaintReg2->IEBitmap->AssignImage(reg2);
   delete reg2;
   }
PaintPanorama->Update();
PaintReg1->Update();
PaintReg2->Update();
etime = Time();
duration = etime - stime;
StatusBarMatch->Panels->Items[4]->Text = "ORSA done: " + duration.FormatString("hh:nn:ss.zzzz");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::trackSigmaChange(TObject *Sender)
{
labSigma->Caption = "Sigma: " + FloatToStr((double)trackSigma->Position / 10.0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::trackMatchChange(TObject *Sender)
{
labMatch->Caption = "SIFT match ratio: " + FloatToStr((double)trackMatch->Position / 10.0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::trackPrecissionChange(TObject *Sender)
{
labPrecission->Caption = "ORSA precission: " + FloatToStr((double)trackPrecission->Position / 10.0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::rgpMatchesClick(TObject *Sender)
{
showMatches(rgpMatches->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::chkIntersectionClick(TObject *Sender)
{
// toggle intersection box
/*
PaintPanorama->RemoveAllObjects();
if (chkIntersection->Checked)
   {
   int hobj = PaintPanorama->AddNewObject();
   PaintPanorama->ObjPenColor[hobj] = clRed;
   PaintPanorama->ObjKind[hobj] = iekBOX;
   PaintPanorama->ObjPenWidth[hobj] = 2;
   PaintPanorama->ObjTop[hobj]    =  intersectionBox.top;
   PaintPanorama->ObjLeft[hobj]   =  intersectionBox.left;
   PaintPanorama->ObjHeight[hobj] =  intersectionBox.bottom - PaintPanorama->ObjTop[hobj];
   PaintPanorama->ObjWidth[hobj]  =  intersectionBox.right  - PaintPanorama->ObjLeft[hobj];
   PaintPanorama->ObjID[hobj] = 1;
   }
*/
}
//---------------------------------------------------------------------------
void __fastcall TForm1::executeEntry(String entry_name)
{
if (dll_instance)
   {
   ExecuteAddr = (ORSA_entry)GetProcAddress(dll_instance, AnsiString(entry_name).c_str());
   try
	  {
	   ExecutionStatus = ExecuteAddr(SiftParams, DataOrsa);
	   if (ExecutionStatus > 0)
		  {
		  // ups!
		  return;
		  }
	   }
	catch (...)
	   {
	   }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::getScline(imageData &image, TIEBitmap *bitmap)
{
image.Width  = bitmap->Width;
image.Height = bitmap->Height;
image.Scline = new Byte*[image.Height];
for (int i = 0; i < image.Height; i++)
	image.Scline[i] = (Byte*)bitmap->ScanLine[i];
}
//---------------------------------------------------------------------------
TIEBitmap* __fastcall TForm1::BitmapFromScline(imageData &image)
{
TIEBitmap *bitmap = new TIEBitmap(image.Width, image.Height, ie24RGB);
Byte *outLine;
Byte *inLine;
for (int i = 0; i < image.Height; i++)
	{
	outLine = (Byte*)bitmap->Scanline[i];
	inLine  = image.Scline[i];
	for (int j = 0; j < image.Width * 3; j++)
		{
		outLine[j] = inLine[j];
		}
	}
return bitmap;
}
//---------------------------------------------------------------------------

