unit ORSA;
{**************************************************************************}
{                                                                          }
{    This C DLL header file first (automatic) conversion generated by:     }
{    HeadConv 4.0 (c) 2000 by Bob Swart (aka Dr.Bob - www.drbob42.com)     }
{      Final Delphi-Jedi (Darth) command-line units edition                }
{                                                                          }
{    Generated Date: 13.10.2016.                                            }
{    Generated Time:  9:13:35                                              }
{                                                                          }
{**************************************************************************}

interface
uses
{$IFDEF WIN32}
  Windows,iexBitmaps, System.Classes;
{$ELSE}
  Wintypes, WinProcs, iexBitmaps, System.Classes;
{$ENDIF}


{=> d:\petra\orsahomographydll\ORSA.H <=}

{$IFNDEF ORSA_H}
{$DEFINE ORSA_H}

{*$INCLUDE "iexBitmaps.hpp"*}

const
  OriSize = 8;
const
  IndexSize = 4;
const
  VecLength = IndexSize* IndexSize* OriSize;
{+// Keypoint structure: }
{-position: x,y }
{-scale: s }
{-orientation: angle }
{-descriptor: array of gradient orientation histograms in a neighbors }
{= }
type
  keypoint = record
    x, y, scale, angle: Single;
    vec: Array[0..VecLength-1] of Single;
  end {keypoint};
type
  siftPar = record
    OctaveMax: Integer;
    DoubleImSize: Integer;
    order: Integer;
    InitSigma : Single;
    BorderList: Integer;
    Scales : Integer;
    PeakThresh : Single;
    EdgeThresh : Single;
    EdgeThresh1 : Single;
    OriBins : Integer;
    OriSigma: Single;
    OriHistThresh: Single;
    MaxIndexVal : Single;
    MagFactor : Single;
    IndexSigma : Single;
    IgnoreGradSign: Integer;
    MatchRatio: Single;
    MatchXradius : Single;
    MatchYradius: Single;
    noncorrectlylocalized: Integer;
  end {siftPar};

type
  PByte = ^Byte;

  matchings = record
    x1, y1, x2, y2: Single;
  end {matchings};

  matchData = record
    Data:  array of matchings;
    Count: Integer;
  end;

  keypointsData = record
    Data:  array of keypoint;
    Count: Integer;
  end;

  imageData = record
    Width: Integer;
    Height: Integer;
    Scline: array of PByte;
  end;

  siftData = record
    Image: imageData;
    KeyPoints: keypointsData;
  end;

  orsaIntersection = record
    top: Integer;
    bottom: Integer;
    left: Integer;
    right: Integer;
  end;

  orsaData = record
    rgb: Array[0..3] of Byte;
    Source: siftData;
    Target: siftData;
    SiftMatch, InLiers, OutLiers: matchData;
    OutputPanorama: Boolean;
    OutputReg1: Boolean;
    OutputReg2: Boolean;
    Panorama: imageData;
    Reg1: imageData;
    Reg2: imageData;
    Intersection: orsaIntersection;
    Precission: Double;

  end;

type
  ORSA_entry = function(var SiftParams: SiftPar; var DataOrsa: orsaData): Integer; stdcall;
{$ENDIF}

var
  DLLLoaded: Boolean { is DLL (dynamically) loaded already? }
    {$IFDEF WIN32} = False; {$ENDIF}
  DLLHandle: THandle;
implementation

var
  SaveExit: pointer;
{$IFNDEF MSDOS}
  ErrorMode: Integer;
{$ENDIF}

procedure NewExit; far;
  begin
    ExitProc := SaveExit;
    FreeLibrary(DLLHandle)
  end {NewExit};

procedure LoadDLL;
begin
  if DLLLoaded then Exit;
{$IFNDEF MSDOS}
  ErrorMode := SetErrorMode($8000{SEM_NoOpenFileErrorBox});
{$ENDIF}
  DLLHandle := LoadLibrary('Orsa.dll');
  if DLLHandle >= 32 then
  begin
    DLLLoaded := True;
    SaveExit := ExitProc;
    ExitProc := @NewExit;
  end
  else
  begin
    DLLLoaded := False;
    { Error: ORSA.DLL could not be loaded !! }
  end;
{$IFNDEF MSDOS}
  SetErrorMode(ErrorMode)
{$ENDIF}
end {LoadDLL};

begin
  LoadDLL;
end.
